## mycompiler.mystatement
Class Expr

    java.lang.Object
      mycompiler.mystatement.Statement
          mycompiler.mystatement.ExprStmt
              mycompiler.mystatement.Expr

All Implemented Interfaces:
  ITypeReplacementListener

Direct Known Subclasses:
  Assign, BinaryExpr, InstVar, Literal, LocalOrFieldVar, MethodCall, NewArray, NewClass, This, UnaryExpr

    public abstract class Expr

extends ExprStmt

Field Summary
`UsedId` `usedid`

Fields inherited from class mycompiler.mystatement.ExprStmt
`type`

Constructor Summary
`Expr()`

Method Summary
`de.dhbwstuttgart.typeinference.Menge` `get_Name_Menge()`
`abstract java.lang.String` `get_Name()`
`de.dhbwstuttgart.typeinference.Menge` `get_Type_Menge()`
`UsedId` `get_UsedId()`
`abstract void` `sc_check(de.dhbwstuttgart.typeinference.Menge classname, java.util.Hashtable ch, java.util.Hashtable bh, boolean ext, java.util.Hashtable parach, java.util.Hashtable parabh)`
`void` `set_Type(Type type)`
`void` `set_UsedId(UsedId ui)`
`abstract CTripleSet` `TRExp(CSubstitutionSet sigma, CTypeAssumptionSet V, CSupportData supportData)`
`CMultiplyTupleSet` `TRMultiply(CMultiplyTuple tuple, Expr t, CSupportData supportData)` (siehe Algorithmus 5.29 TRMultiply, Martin Pl�micke) Author: J�rg B�uerle
`CMultiplyTupleSet` `TRTuple(CMultiplyTuple result, de.dhbwstuttgart.typeinference.Menge<Expr> terms, CSupportData supportData)` (siehe Algorithmus 5.28 TRTuple, Martin Pl�micke) Author: J�rg B�uerle

Methods inherited from class mycompiler.mystatement.ExprStmt
`getType, getTypeLineNumber, getTypeName, replaceType, setType`

Methods inherited from class mycompiler.mystatement.Statement
`codegen, TRStatement`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### usedid

    public UsedId usedid

Constructor Detail

### Expr

    public Expr()

Method Detail

### set_Type

    public void set_Type(Type type)

### set_UsedId

    public void set_UsedId(UsedId ui)

### get_UsedId

    public UsedId get_UsedId()

### get_Name_Menge

    public de.dhbwstuttgart.typeinference.Menge get_Name_Menge()

### get_Type_Menge

    public de.dhbwstuttgart.typeinference.Menge get_Type_Menge()

### sc_check

    public abstract void sc_check(de.dhbwstuttgart.typeinference.Menge classname,
                                  java.util.Hashtable ch,
                                  java.util.Hashtable bh,
                                  boolean ext,
                                  java.util.Hashtable parach,
                                  java.util.Hashtable parabh)
                           throws SCStatementException

  Throws:
    `SCStatementException`

### get_Name

    public abstract java.lang.String get_Name()

### TRExp

    public abstract CTripleSet TRExp(CSubstitutionSet sigma,
                                     CTypeAssumptionSet V,
                                     CSupportData supportData)
                              throws CTypeReconstructionException

  Throws:
    `CTypeReconstructionException`

### TRTuple

    public CMultiplyTupleSet TRTuple(CMultiplyTuple result,
                                     de.dhbwstuttgart.typeinference.Menge<Expr> terms,
                                     CSupportData supportData)

  (siehe Algorithmus 5.28 TRTuple, Martin Pl�micke)
  Author: J�rg B�uerle

  Parameters:
    `result` -
    `terms` -
    `supportData` -
  Returns:

### TRMultiply

    public CMultiplyTupleSet TRMultiply(CMultiplyTuple tuple,
                                        Expr t,
                                        CSupportData supportData)

  (siehe Algorithmus 5.29 TRMultiply, Martin Pl�micke)
  Author: J�rg B�uerle

  Parameters:
    `tuple` -
    `t` -
    `supportData` -
  Returns: